const defaultState = {
  movies: [],
  filter: "",
  perPage: 30,
  selectedMovie: {
    imdbId: "",
    fetchingDetails: false,
  },
};

export default function movieStore(state = defaultState, action) {
  switch (action.type) {
    case 'MOVIE_LIST_FETCH_FULFILLED':
      return Object.assign({}, state, {
        movies: action.payload.data,
      })
    case 'MOVIE_GET_DETAILS_PENDING':
      return Object.assign({}, state, {
        selectedMovie: Object.assign({}, state.selectedMovie, {
          fetchingDetails: true,
        }),
      })
    case 'MOVIE_GET_DETAILS_FULFILLED':
      let movies = state.movies.slice();
      let index = movies.map((el) => el.imdb_id).indexOf(action.payload.data.imdb_id);
      movies[index] = action.payload.data;
      return Object.assign({}, state, {
        movies: movies,
        selectedMovie: Object.assign({}, state.selectedMovie, {
          fetchingDetails: false,
        }),
      })
    case 'SELECT_MOVIE':
      // Don't select the movie if we're fetching another movie's details
      if (state.selectedMovie.fetchingDetails) {
        return state
      }

      return Object.assign({}, state, {
        selectedMovie: Object.assign({}, state.selectedMovie, {
          imdbId: action.imdbId,
        }),
      })
    default:
      return state
  }
}
